import numpy as np
from PIL import Image
from PIL import ImageDraw, ImageFont
from math import ceil
import sys
import re



def stats(ar,lnum):
    #print(np.mean(ar))
    ct = ((np.std(ar)/np.mean(ar))*100)
    bsigry=[np.histogram(ar, bins=2, range=None, density=False, weights=None)]
    num = (bsigry[0][0][0])
    if ct > 27 and num > 4 and lnum > 30:
     dd = {}
     volume= (bsigry[0][0][0])
     dd['volume'] = volume
     dd['lnum'] = lnum
     #print(lnum)
     #print(str(lnum)+" "+str(250-lnum))
     #print((np.std(ar)/np.mean(ar))*100)
     #print(bsigry)
     #print(ct)
     return dd
     #print("present")


def analyzeit(img,aax,draw,cnt,fnt,aay,wdim,ldim):
 #aay = 161
 #ldim = 210
 #wdim = 40
 box = (aax,aay,aax+wdim,aay+ldim)
 area = img.crop(box)
 area.save("aa.png")
 szarea = area.size
 px = list(area.getdata())

 dat = np.array(px)
 rdat = []
 gdat = []
 bdat = []
 for i in dat:
   rdat.append(i[0])
   gdat.append(i[1])
   bdat.append(i[2])
 ardat = np.reshape(rdat,(szarea[1],szarea[0]))
 agdat = np.reshape(gdat,(szarea[1],szarea[0]))
 abdat = np.reshape(bdat,(szarea[1],szarea[0]))

 ll = []
 volume = 0
 for i in range(10, 170):
  dd = stats(ardat[i,0:],i)
  if dd is not None:
   ll.append(dd['lnum'])
   volume = volume + (dd['volume']*dd['lnum'])

 ll = np.array(ll)
 #print(np.min(ll))
 #print(np.max(ll))
 tipline = np.max(ll)
 print(str(8-cnt) + ' '+str(np.min(ll))+' '+(str(np.max(ll))))
 gg = {}
 gg['draw'] = draw
 gg['volume'] = volume
 gg['lnmin'] = np.min(ll)
 gg['lnmax'] = np.max(ll)
 gg['aax'] = aax
 '''
 draw.text((aax,aay+(np.min(ll)-15)), str(np.min(ll)+aay), font=fnt, fill=(255,255,255,128))
 draw.text((aax,aay+(np.max(ll))), str(np.max(ll)+aay), font=fnt, fill=(255,255,255,128))
 draw.text((aax-10,aay+(np.max(ll)+20)), 'V: '+str(volume), font=fnt, fill=(255,255,255,128))
 draw.line((aax, aay+np.max(ll), aax+wdim, aay+np.max(ll)), fill="red")
 draw.line((aax, aay+np.min(ll), aax+wdim, aay+np.min(ll)), fill="red")
 '''
 #return draw
 return gg

img = Image.open(sys.argv[1])
vol = float(sys.argv[2])
aay = 161
ldim = 210
wdim = 40
print(sys.argv[1])
img =img.rotate(-3)
fnt = ImageFont.truetype('arial.ttf', 12)
#fnt = ''
volume = []
draw = ImageDraw.Draw(img)

ggdat = []
for i in range(0,8):
 aax = 55 + (68*i)
 #gg = analyzeit(img,aax,draw,i,fnt)
 gg = analyzeit(img,aax,draw,i,fnt,aay,wdim,ldim)
 #draw = analyzeit(img,aax,draw,i,fnt)
 ggdat.append(gg)
 draw = gg['draw']
 volume.append(gg['volume'])

volume = np.array(volume)
print(np.mean(volume))
volperpx = round((np.mean(volume) / vol),2)

for gg in ggdat:
 #cvol = round(((np.mean(volume) + (gg['volume']-np.mean(volume)))/vol),2)
 cvol = ((gg['volume'] - np.mean(volume)))+np.mean(volume)
 cvol = (cvol / volperpx)/1000
 cvol = round(cvol,2)
 draw.text((gg['aax'],aay+(gg['lnmin']-15)), str(gg['lnmin']+aay), font=fnt, fill=(255,255,255,128))
 draw.text((gg['aax'],aay+(gg['lnmax'])), str(gg['lnmax']+aay), font=fnt, fill=(255,255,255,128))
 draw.text((gg['aax']-3,aay+(gg['lnmax']+20)), str(cvol)+'ul', font=fnt, fill=(255,255,255,128))
 draw.line((gg['aax'], aay+gg['lnmax'], gg['aax']+wdim, aay+gg['lnmax']), fill="red")
 draw.line((gg['aax'], aay+gg['lnmin'], gg['aax']+wdim, aay+gg['lnmin']), fill="red")


#draw.text((50, 50, ("Pixel volume: "+str(np.mean(volume))), font=fnt, fill=(255,255,255,128))
draw.text((30,20-13), "Aspiration volume: "+str(vol)+"ul", font=fnt, fill=(255,255,255,128))
draw.text((30,20), "Avg pixel volume: "+str(np.mean(volume)), font=fnt, fill=(255,255,255,128))
draw.text((30,20+13), "Vol/px: "+str(volperpx), font=fnt, fill=(255,255,255,128))
img.save(re.sub('.jpg', '', sys.argv[1])+"newpic.png")
draw.text((30,20+26), "CV: "+str(round((np.std(volume)/np.mean(volume))*100))+"%", font=fnt, fill=(255,255,255,128))
img.save(re.sub('.jpg', '', sys.argv[1])+"newpic.png")

